diff --git a/src/backend/parser/gram.y b/src/backend/parser/gram.y
index c5086846de..d7a885e78a 100644
--- a/src/backend/parser/gram.y
+++ b/src/backend/parser/gram.y
@@ -12906,7 +12921,7 @@ ConstDatetime:
 						$$ = SystemTypeName("timestamp");
 					$$->location = @1;
 				}
-			| TIME '(' Iconst ')' opt_timezone
+			| TIME LPAREN Iconst RPAREN opt_timezone
 				{
 					if ($5)
 						$$ = SystemTypeName("timetz");
@@ -13003,7 +13018,7 @@ interval_second:
 				{
 					$$ = list_make1(makeIntConst(INTERVAL_MASK(SECOND), @1));
 				}
-			| SECOND_P '(' Iconst ')'
+			| SECOND_P LPAREN Iconst RPAREN
 				{
 					$$ = list_make2(makeIntConst(INTERVAL_MASK(SECOND), @1),
 									makeIntConst($3, @3));
@@ -13027,7 +13042,7 @@ interval_second:
  * because that use of AND conflicts with AND as a boolean operator.  So,
  * b_expr is used in BETWEEN and we remove boolean keywords from b_expr.
  *
- * Note that '(' a_expr ')' is a b_expr, so an unrestricted expression can
+ * Note that LPAREN a_expr RPAREN is a b_expr, so an unrestricted expression can
  * always be used by surrounding it with parens.
  *
  * c_expr is all the productions that are common to a_expr and b_expr;
@@ -13065,27 +13080,27 @@ a_expr:		c_expr									{ $$ = $1; }
 		 * If you add more explicitly-known operators, be sure to add them
 		 * also to b_expr and to the MathOp list below.
 		 */
-			| '+' a_expr					%prec UMINUS
+			| PLUS a_expr					%prec UMINUS
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, $2, @1); }
-			| '-' a_expr					%prec UMINUS
+			| MINUS a_expr					%prec UMINUS
 				{ $$ = doNegate($2, @1); }
-			| a_expr '+' a_expr
+			| a_expr PLUS a_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", $1, $3, @2); }
-			| a_expr '-' a_expr
+			| a_expr MINUS a_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", $1, $3, @2); }
-			| a_expr '*' a_expr
+			| a_expr STAR a_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", $1, $3, @2); }
-			| a_expr '/' a_expr
+			| a_expr SLASH a_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", $1, $3, @2); }
-			| a_expr '%' a_expr
+			| a_expr PERCENT a_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", $1, $3, @2); }
-			| a_expr '^' a_expr
+			| a_expr CARET a_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", $1, $3, @2); }
-			| a_expr '<' a_expr
+			| a_expr LESS a_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", $1, $3, @2); }
-			| a_expr '>' a_expr
+			| a_expr GREATER a_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", $1, $3, @2); }
-			| a_expr '=' a_expr
+			| a_expr EQUALS a_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", $1, $3, @2); }
 			| a_expr LESS_EQUALS a_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", $1, $3, @2); }
@@ -13309,11 +13324,11 @@ a_expr:		c_expr									{ $$ = $1; }
 				{
 					$$ = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", $1, $6, @2);
 				}
-			| a_expr IS OF '(' type_list ')'			%prec IS
+			| a_expr IS OF LPAREN type_list RPAREN			%prec IS
 				{
 					$$ = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", $1, (Node *) $5, @2);
 				}
-			| a_expr IS NOT OF '(' type_list ')'		%prec IS
+			| a_expr IS NOT OF LPAREN type_list RPAREN		%prec IS
 				{
 					$$ = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", $1, (Node *) $6, @2);
 				}
@@ -13402,7 +13417,7 @@ a_expr:		c_expr									{ $$ = $1; }
 					n->location = @2;
 					$$ = (Node *)n;
 				}
-			| a_expr subquery_Op sub_type '(' a_expr ')'		%prec Op
+			| a_expr subquery_Op sub_type LPAREN a_expr RPAREN		%prec Op
 				{
 					if ($3 == ANY_SUBLINK)
 						$$ = (Node *) makeA_Expr(AEXPR_OP_ANY, $2, $1, $5, @2);
@@ -13465,27 +13480,27 @@ b_expr:		c_expr
 				{ $$ = $1; }
 			| b_expr TYPECAST Typename
 				{ $$ = makeTypeCast($1, $3, @2); }
-			| '+' b_expr					%prec UMINUS
+			| PLUS b_expr					%prec UMINUS
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, $2, @1); }
-			| '-' b_expr					%prec UMINUS
+			| MINUS b_expr					%prec UMINUS
 				{ $$ = doNegate($2, @1); }
-			| b_expr '+' b_expr
+			| b_expr PLUS b_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", $1, $3, @2); }
-			| b_expr '-' b_expr
+			| b_expr MINUS b_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", $1, $3, @2); }
-			| b_expr '*' b_expr
+			| b_expr STAR b_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", $1, $3, @2); }
-			| b_expr '/' b_expr
+			| b_expr SLASH b_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", $1, $3, @2); }
-			| b_expr '%' b_expr
+			| b_expr PERCENT b_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", $1, $3, @2); }
-			| b_expr '^' b_expr
+			| b_expr CARET b_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", $1, $3, @2); }
-			| b_expr '<' b_expr
+			| b_expr LESS b_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", $1, $3, @2); }
-			| b_expr '>' b_expr
+			| b_expr GREATER b_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", $1, $3, @2); }
-			| b_expr '=' b_expr
+			| b_expr EQUALS b_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", $1, $3, @2); }
 			| b_expr LESS_EQUALS b_expr
 				{ $$ = (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", $1, $3, @2); }
@@ -13507,11 +13522,11 @@ b_expr:		c_expr
 				{
 					$$ = (Node *) makeSimpleA_Expr(AEXPR_NOT_DISTINCT, "=", $1, $6, @2);
 				}
-			| b_expr IS OF '(' type_list ')'		%prec IS
+			| b_expr IS OF LPAREN type_list RPAREN		%prec IS
 				{
 					$$ = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", $1, (Node *) $5, @2);
 				}
-			| b_expr IS NOT OF '(' type_list ')'	%prec IS
+			| b_expr IS NOT OF LPAREN type_list RPAREN	%prec IS
 				{
 					$$ = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", $1, (Node *) $6, @2);
 				}
@@ -13553,7 +13568,7 @@ c_expr:		columnref								{ $$ = $1; }
 					else
 						$$ = (Node *) p;
 				}
-			| '(' a_expr ')' opt_indirection
+			| LPAREN a_expr RPAREN opt_indirection
 				{
 					if ($4)
 					{
@@ -13607,7 +13622,7 @@ c_expr:		columnref								{ $$ = $1; }
 					/*
 					 * Because the select_with_parens nonterminal is designed
 					 * to "eat" as many levels of parens as possible, the
-					 * '(' a_expr ')' opt_indirection production above will
+					 * LPAREN a_expr RPAREN opt_indirection production above will
 					 * fail to match a sub-SELECT with indirection decoration;
 					 * the sub-SELECT won't be regarded as an a_expr as long
 					 * as there are parens around it.  To support applying
@@ -13675,7 +13690,7 @@ c_expr:		columnref								{ $$ = $1; }
 					r->location = @1;
 					$$ = (Node *)r;
 				}
-			| GROUPING '(' expr_list ')'
+			| GROUPING LPAREN expr_list RPAREN
 			  {
 				  GroupingFunc *g = makeNode(GroupingFunc);
 				  g->args = $3;
@@ -13684,31 +13699,31 @@ c_expr:		columnref								{ $$ = $1; }
 			  }
 		;
 
-func_application: func_name '(' ')'
+func_application: func_name LPAREN RPAREN
 				{
 					$$ = (Node *) makeFuncCall($1, NIL, @1);
 				}
-			| func_name '(' func_arg_list opt_sort_clause ')'
+			| func_name LPAREN func_arg_list opt_sort_clause RPAREN
 				{
 					FuncCall *n = makeFuncCall($1, $3, @1);
 					n->agg_order = $4;
 					$$ = (Node *)n;
 				}
-			| func_name '(' VARIADIC func_arg_expr opt_sort_clause ')'
+			| func_name LPAREN VARIADIC func_arg_expr opt_sort_clause RPAREN
 				{
 					FuncCall *n = makeFuncCall($1, list_make1($4), @1);
 					n->func_variadic = true;
 					n->agg_order = $5;
 					$$ = (Node *)n;
 				}
-			| func_name '(' func_arg_list ',' VARIADIC func_arg_expr opt_sort_clause ')'
+			| func_name LPAREN func_arg_list COMMA VARIADIC func_arg_expr opt_sort_clause RPAREN
 				{
 					FuncCall *n = makeFuncCall($1, lappend($3, $6), @1);
 					n->func_variadic = true;
 					n->agg_order = $7;
 					$$ = (Node *)n;
 				}
-			| func_name '(' ALL func_arg_list opt_sort_clause ')'
+			| func_name LPAREN ALL func_arg_list opt_sort_clause RPAREN
 				{
 					FuncCall *n = makeFuncCall($1, $4, @1);
 					n->agg_order = $5;
@@ -13718,20 +13733,20 @@ func_application: func_name '(' ')'
 					 */
 					$$ = (Node *)n;
 				}
-			| func_name '(' DISTINCT func_arg_list opt_sort_clause ')'
+			| func_name LPAREN DISTINCT func_arg_list opt_sort_clause RPAREN
 				{
 					FuncCall *n = makeFuncCall($1, $4, @1);
 					n->agg_order = $5;
 					n->agg_distinct = true;
 					$$ = (Node *)n;
 				}
-			| func_name '(' '*' ')'
+			| func_name LPAREN STAR RPAREN
 				{
 					/*
 					 * We consider AGGREGATE(*) to invoke a parameterless
 					 * aggregate.  This does the right thing for COUNT(*),
 					 * and there are no other aggregates in SQL that accept
-					 * '*' as parameter.
+					 * STAR as parameter.
 					 *
 					 * The FuncCall node is also marked agg_star = true,
 					 * so that later processing can detect what the argument
@@ -13807,7 +13822,7 @@ func_expr_windowless:
  * Special expressions that are considered to be functions.
  */
 func_expr_common_subexpr:
-			COLLATION FOR '(' a_expr ')'
+			COLLATION FOR LPAREN a_expr RPAREN
 				{
 					$$ = (Node *) makeFuncCall(SystemFuncName("pg_collation_for"),
 											   list_make1($4),
@@ -13821,7 +13836,7 @@ func_expr_common_subexpr:
 				{
 					$$ = makeSQLValueFunction(SVFOP_CURRENT_TIME, -1, @1);
 				}
-			| CURRENT_TIME '(' Iconst ')'
+			| CURRENT_TIME LPAREN Iconst RPAREN
 				{
 					$$ = makeSQLValueFunction(SVFOP_CURRENT_TIME_N, $3, @1);
 				}
@@ -13829,7 +13844,7 @@ func_expr_common_subexpr:
 				{
 					$$ = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP, -1, @1);
 				}
-			| CURRENT_TIMESTAMP '(' Iconst ')'
+			| CURRENT_TIMESTAMP LPAREN Iconst RPAREN
 				{
 					$$ = makeSQLValueFunction(SVFOP_CURRENT_TIMESTAMP_N, $3, @1);
 				}
@@ -13837,7 +13852,7 @@ func_expr_common_subexpr:
 				{
 					$$ = makeSQLValueFunction(SVFOP_LOCALTIME, -1, @1);
 				}
-			| LOCALTIME '(' Iconst ')'
+			| LOCALTIME LPAREN Iconst RPAREN
 				{
 					$$ = makeSQLValueFunction(SVFOP_LOCALTIME_N, $3, @1);
 				}
@@ -13845,7 +13860,7 @@ func_expr_common_subexpr:
 				{
 					$$ = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP, -1, @1);
 				}
-			| LOCALTIMESTAMP '(' Iconst ')'
+			| LOCALTIMESTAMP LPAREN Iconst RPAREN
 				{
 					$$ = makeSQLValueFunction(SVFOP_LOCALTIMESTAMP_N, $3, @1);
 				}
@@ -13873,13 +13888,13 @@ func_expr_common_subexpr:
 				{
 					$$ = makeSQLValueFunction(SVFOP_CURRENT_SCHEMA, -1, @1);
 				}
-			| CAST '(' a_expr AS Typename ')'
+			| CAST LPAREN a_expr AS Typename RPAREN
 				{ $$ = makeTypeCast($3, $5, @1); }
-			| EXTRACT '(' extract_list ')'
+			| EXTRACT LPAREN extract_list RPAREN
 				{
 					$$ = (Node *) makeFuncCall(SystemFuncName("date_part"), $3, @1);
 				}
-			| OVERLAY '(' overlay_list ')'
+			| OVERLAY LPAREN overlay_list RPAREN
 				{
 					/* overlay(A PLACING B FROM C FOR D) is converted to
 					 * overlay(A, B, C, D)
@@ -13888,19 +13903,19 @@ func_expr_common_subexpr:
 					 */
 					$$ = (Node *) makeFuncCall(SystemFuncName("overlay"), $3, @1);
 				}
-			| POSITION '(' position_list ')'
+			| POSITION LPAREN position_list RPAREN
 				{
 					/* position(A in B) is converted to position(B, A) */
 					$$ = (Node *) makeFuncCall(SystemFuncName("position"), $3, @1);
 				}
-			| SUBSTRING '(' substr_list ')'
+			| SUBSTRING LPAREN substr_list RPAREN
 				{
 					/* substring(A from B for C) is converted to
 					 * substring(A, B, C) - thomas 2000-11-28
 					 */
 					$$ = (Node *) makeFuncCall(SystemFuncName("substring"), $3, @1);
 				}
-			| TREAT '(' a_expr AS Typename ')'
+			| TREAT LPAREN a_expr AS Typename RPAREN
 				{
 					/* TREAT(expr AS target) converts expr of a particular type to target,
 					 * which is defined to be a subtype of the original expression.
@@ -13915,37 +13930,37 @@ func_expr_common_subexpr:
 												list_make1($3),
 												@1);
 				}
-			| TRIM '(' BOTH trim_list ')'
+			| TRIM LPAREN BOTH trim_list RPAREN
 				{
 					/* various trim expressions are defined in SQL
 					 * - thomas 1997-07-19
 					 */
 					$$ = (Node *) makeFuncCall(SystemFuncName("btrim"), $4, @1);
 				}
-			| TRIM '(' LEADING trim_list ')'
+			| TRIM LPAREN LEADING trim_list RPAREN
 				{
 					$$ = (Node *) makeFuncCall(SystemFuncName("ltrim"), $4, @1);
 				}
-			| TRIM '(' TRAILING trim_list ')'
+			| TRIM LPAREN TRAILING trim_list RPAREN
 				{
 					$$ = (Node *) makeFuncCall(SystemFuncName("rtrim"), $4, @1);
 				}
-			| TRIM '(' trim_list ')'
+			| TRIM LPAREN trim_list RPAREN
 				{
 					$$ = (Node *) makeFuncCall(SystemFuncName("btrim"), $3, @1);
 				}
-			| NULLIF '(' a_expr ',' a_expr ')'
+			| NULLIF LPAREN a_expr COMMA a_expr RPAREN
 				{
 					$$ = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", $3, $5, @1);
 				}
-			| COALESCE '(' expr_list ')'
+			| COALESCE LPAREN expr_list RPAREN
 				{
 					CoalesceExpr *c = makeNode(CoalesceExpr);
 					c->args = $3;
 					c->location = @1;
 					$$ = (Node *)c;
 				}
-			| GREATEST '(' expr_list ')'
+			| GREATEST LPAREN expr_list RPAREN
 				{
 					MinMaxExpr *v = makeNode(MinMaxExpr);
 					v->args = $3;
@@ -13953,7 +13968,7 @@ func_expr_common_subexpr:
 					v->location = @1;
 					$$ = (Node *)v;
 				}
-			| LEAST '(' expr_list ')'
+			| LEAST LPAREN expr_list RPAREN
 				{
 					MinMaxExpr *v = makeNode(MinMaxExpr);
 					v->args = $3;
@@ -13961,37 +13976,37 @@ func_expr_common_subexpr:
 					v->location = @1;
 					$$ = (Node *)v;
 				}
-			| XMLCONCAT '(' expr_list ')'
+			| XMLCONCAT LPAREN expr_list RPAREN
 				{
 					$$ = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, $3, @1);
 				}
-			| XMLELEMENT '(' NAME_P ColLabel ')'
+			| XMLELEMENT LPAREN NAME_P ColLabel RPAREN
 				{
 					$$ = makeXmlExpr(IS_XMLELEMENT, $4, NIL, NIL, @1);
 				}
-			| XMLELEMENT '(' NAME_P ColLabel ',' xml_attributes ')'
+			| XMLELEMENT LPAREN NAME_P ColLabel COMMA xml_attributes RPAREN
 				{
 					$$ = makeXmlExpr(IS_XMLELEMENT, $4, $6, NIL, @1);
 				}
-			| XMLELEMENT '(' NAME_P ColLabel ',' expr_list ')'
+			| XMLELEMENT LPAREN NAME_P ColLabel COMMA expr_list RPAREN
 				{
 					$$ = makeXmlExpr(IS_XMLELEMENT, $4, NIL, $6, @1);
 				}
-			| XMLELEMENT '(' NAME_P ColLabel ',' xml_attributes ',' expr_list ')'
+			| XMLELEMENT LPAREN NAME_P ColLabel COMMA xml_attributes COMMA expr_list RPAREN
 				{
 					$$ = makeXmlExpr(IS_XMLELEMENT, $4, $6, $8, @1);
 				}
-			| XMLEXISTS '(' c_expr xmlexists_argument ')'
+			| XMLEXISTS LPAREN c_expr xmlexists_argument RPAREN
 				{
 					/* xmlexists(A PASSING [BY REF] B [BY REF]) is
 					 * converted to xmlexists(A, B)*/
 					$$ = (Node *) makeFuncCall(SystemFuncName("xmlexists"), list_make2($3, $4), @1);
 				}
-			| XMLFOREST '(' xml_attribute_list ')'
+			| XMLFOREST LPAREN xml_attribute_list RPAREN
 				{
 					$$ = makeXmlExpr(IS_XMLFOREST, NULL, $3, NIL, @1);
 				}
-			| XMLPARSE '(' document_or_content a_expr xml_whitespace_option ')'
+			| XMLPARSE LPAREN document_or_content a_expr xml_whitespace_option RPAREN
 				{
 					XmlExpr *x = (XmlExpr *)
 						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
@@ -14000,20 +14015,20 @@ func_expr_common_subexpr:
 					x->xmloption = $3;
 					$$ = (Node *)x;
 				}
-			| XMLPI '(' NAME_P ColLabel ')'
+			| XMLPI LPAREN NAME_P ColLabel RPAREN
 				{
 					$$ = makeXmlExpr(IS_XMLPI, $4, NULL, NIL, @1);
 				}
-			| XMLPI '(' NAME_P ColLabel ',' a_expr ')'
+			| XMLPI LPAREN NAME_P ColLabel COMMA a_expr RPAREN
 				{
 					$$ = makeXmlExpr(IS_XMLPI, $4, NULL, list_make1($6), @1);
 				}
-			| XMLROOT '(' a_expr ',' xml_root_version opt_xml_root_standalone ')'
+			| XMLROOT LPAREN a_expr COMMA xml_root_version opt_xml_root_standalone RPAREN
 				{
 					$$ = makeXmlExpr(IS_XMLROOT, NULL, NIL,
 									 list_make3($3, $5, $6), @1);
 				}
-			| XMLSERIALIZE '(' document_or_content a_expr AS SimpleTypename ')'
+			| XMLSERIALIZE LPAREN document_or_content a_expr AS SimpleTypename RPAREN
 				{
 					XmlSerialize *n = makeNode(XmlSerialize);
 					n->xmloption = $3;
@@ -14033,21 +14048,21 @@ xml_root_version: VERSION_P a_expr
 				{ $$ = makeNullAConst(-1); }
 		;
 
-opt_xml_root_standalone: ',' STANDALONE_P YES_P
+opt_xml_root_standalone: COMMA STANDALONE_P YES_P
 				{ $$ = makeIntConst(XML_STANDALONE_YES, -1); }
-			| ',' STANDALONE_P NO
+			| COMMA STANDALONE_P NO
 				{ $$ = makeIntConst(XML_STANDALONE_NO, -1); }
-			| ',' STANDALONE_P NO VALUE_P
+			| COMMA STANDALONE_P NO VALUE_P
 				{ $$ = makeIntConst(XML_STANDALONE_NO_VALUE, -1); }
 			| /*EMPTY*/
 				{ $$ = makeIntConst(XML_STANDALONE_OMITTED, -1); }
 		;
 
-xml_attributes: XMLATTRIBUTES '(' xml_attribute_list ')'	{ $$ = $3; }
+xml_attributes: XMLATTRIBUTES LPAREN xml_attribute_list RPAREN	{ $$ = $3; }
 		;
 
 xml_attribute_list:	xml_attribute_el					{ $$ = list_make1($1); }
-			| xml_attribute_list ',' xml_attribute_el	{ $$ = lappend($1, $3); }
+			| xml_attribute_list COMMA xml_attribute_el	{ $$ = lappend($1, $3); }
 		;
 
 xml_attribute_el: a_expr AS ColLabel
@@ -14107,12 +14122,12 @@ xml_passing_mech:
  * Aggregate decoration clauses
  */
 within_group_clause:
-			WITHIN GROUP_P '(' sort_clause ')'		{ $$ = $4; }
+			WITHIN GROUP_P LPAREN sort_clause RPAREN		{ $$ = $4; }
 			| /*EMPTY*/								{ $$ = NIL; }
 		;
 
 filter_clause:
-			FILTER '(' WHERE a_expr ')'				{ $$ = $4; }
+			FILTER LPAREN WHERE a_expr RPAREN				{ $$ = $4; }
 			| /*EMPTY*/								{ $$ = NULL; }
 		;
 
@@ -14127,7 +14142,7 @@ window_clause:
 
 window_definition_list:
 			window_definition						{ $$ = list_make1($1); }
-			| window_definition_list ',' window_definition
+			| window_definition_list COMMA window_definition
 													{ $$ = lappend($1, $3); }
 		;
 
@@ -14159,8 +14174,8 @@ over_clause: OVER window_specification
 				{ $$ = NULL; }
 		;
 
-window_specification: '(' opt_existing_window_name opt_partition_clause
-						opt_sort_clause opt_frame_clause ')'
+window_specification: LPAREN opt_existing_window_name opt_partition_clause
+						opt_sort_clause opt_frame_clause RPAREN
 				{
 					WindowDef *n = makeNode(WindowDef);
 					n->name = NULL;
@@ -14177,7 +14192,7 @@ window_specification: '(' opt_existing_window_name opt_partition_clause
 		;
 
 /*
- * If we see PARTITION, RANGE, ROWS or GROUPS as the first token after the '('
+ * If we see PARTITION, RANGE, ROWS or GROUPS as the first token after the LPAREN
  * of a window_specification, we want the assumption to be that there is
  * no existing_window_name; but those keywords are unreserved and so could
  * be ColIds.  We fix this by making them have the same precedence as IDENT
@@ -14353,16 +14368,16 @@ opt_window_exclusion_clause:
  * without conflicting with the parenthesized a_expr production.  Without the
  * ROW keyword, there must be more than one a_expr inside the parens.
  */
-row:		ROW '(' expr_list ')'					{ $$ = $3; }
-			| ROW '(' ')'							{ $$ = NIL; }
-			| '(' expr_list ',' a_expr ')'			{ $$ = lappend($2, $4); }
+row:		ROW LPAREN expr_list RPAREN					{ $$ = $3; }
+			| ROW LPAREN RPAREN							{ $$ = NIL; }
+			| LPAREN expr_list COMMA a_expr RPAREN			{ $$ = lappend($2, $4); }
 		;
 
-explicit_row:	ROW '(' expr_list ')'				{ $$ = $3; }
-			| ROW '(' ')'							{ $$ = NIL; }
+explicit_row:	ROW LPAREN expr_list RPAREN				{ $$ = $3; }
+			| ROW LPAREN RPAREN							{ $$ = NIL; }
 		;
 
-implicit_row:	'(' expr_list ',' a_expr ')'		{ $$ = lappend($2, $4); }
+implicit_row:	LPAREN expr_list COMMA a_expr RPAREN		{ $$ = lappend($2, $4); }
 		;
 
 sub_type:	ANY										{ $$ = ANY_SUBLINK; }
@@ -14374,15 +14389,15 @@ all_Op:		Op										{ $$ = $1; }
 			| MathOp								{ $$ = $1; }
 		;
 
-MathOp:		 '+'									{ $$ = "+"; }
-			| '-'									{ $$ = "-"; }
-			| '*'									{ $$ = "*"; }
-			| '/'									{ $$ = "/"; }
-			| '%'									{ $$ = "%"; }
-			| '^'									{ $$ = "^"; }
-			| '<'									{ $$ = "<"; }
-			| '>'									{ $$ = ">"; }
-			| '='									{ $$ = "="; }
+MathOp:		 PLUS									{ $$ = "+"; }
+			| MINUS									{ $$ = "-"; }
+			| STAR									{ $$ = "*"; }
+			| SLASH									{ $$ = "/"; }
+			| PERCENT									{ $$ = "%"; }
+			| CARET									{ $$ = "^"; }
+			| LESS									{ $$ = "<"; }
+			| GREATER									{ $$ = ">"; }
+			| EQUALS									{ $$ = "="; }
 			| LESS_EQUALS							{ $$ = "<="; }
 			| GREATER_EQUALS						{ $$ = ">="; }
 			| NOT_EQUALS							{ $$ = "<>"; }
@@ -14390,21 +14405,21 @@ MathOp:		 '+'									{ $$ = "+"; }
 
 qual_Op:	Op
 					{ $$ = list_make1(makeString($1)); }
-			| OPERATOR '(' any_operator ')'
+			| OPERATOR LPAREN any_operator RPAREN
 					{ $$ = $3; }
 		;
 
 qual_all_Op:
 			all_Op
 					{ $$ = list_make1(makeString($1)); }
-			| OPERATOR '(' any_operator ')'
+			| OPERATOR LPAREN any_operator RPAREN
 					{ $$ = $3; }
 		;
 
 subquery_Op:
 			all_Op
 					{ $$ = list_make1(makeString($1)); }
-			| OPERATOR '(' any_operator ')'
+			| OPERATOR LPAREN any_operator RPAREN
 					{ $$ = $3; }
 			| LIKE
 					{ $$ = list_make1(makeString("~~")); }
@@ -14428,7 +14443,7 @@ expr_list:	a_expr
 				{
 					$$ = list_make1($1);
 				}
-			| expr_list ',' a_expr
+			| expr_list COMMA a_expr
 				{
 					$$ = lappend($1, $3);
 				}
@@ -14439,7 +14454,7 @@ func_arg_list:  func_arg_expr
 				{
 					$$ = list_make1($1);
 				}
-			| func_arg_list ',' func_arg_expr
+			| func_arg_list COMMA func_arg_expr
 				{
 					$$ = lappend($1, $3);
 				}
@@ -14470,25 +14485,25 @@ func_arg_expr:  a_expr
 		;
 
 type_list:	Typename								{ $$ = list_make1($1); }
-			| type_list ',' Typename				{ $$ = lappend($1, $3); }
+			| type_list COMMA Typename				{ $$ = lappend($1, $3); }
 		;
 
-array_expr: '[' expr_list ']'
+array_expr: LBRACKET expr_list RBRACKET
 				{
 					$$ = makeAArrayExpr($2, @1);
 				}
-			| '[' array_expr_list ']'
+			| LBRACKET array_expr_list RBRACKET
 				{
 					$$ = makeAArrayExpr($2, @1);
 				}
-			| '[' ']'
+			| LBRACKET RBRACKET
 				{
 					$$ = makeAArrayExpr(NIL, @1);
 				}
 		;
 
 array_expr_list: array_expr							{ $$ = list_make1($1); }
-			| array_expr_list ',' array_expr		{ $$ = lappend($1, $3); }
+			| array_expr_list COMMA array_expr		{ $$ = lappend($1, $3); }
 		;
 
 
@@ -14611,7 +14626,7 @@ in_expr:	select_with_parens
 					/* other fields will be filled later */
 					$$ = (Node *)n;
 				}
-			| '(' expr_list ')'						{ $$ = (Node *)$2; }
+			| LPAREN expr_list RPAREN						{ $$ = (Node *)$2; }
 		;
 
 /*
@@ -14670,15 +14685,15 @@ columnref:	ColId
 		;
 
 indirection_el:
-			'.' attr_name
+			DOT attr_name
 				{
 					$$ = (Node *) makeString($2);
 				}
-			| '.' '*'
+			| DOT STAR
 				{
 					$$ = (Node *) makeNode(A_Star);
 				}
-			| '[' a_expr ']'
+			| LBRACKET a_expr RBRACKET
 				{
 					A_Indices *ai = makeNode(A_Indices);
 					ai->is_slice = false;
@@ -14686,7 +14701,7 @@ indirection_el:
 					ai->uidx = $2;
 					$$ = (Node *) ai;
 				}
-			| '[' opt_slice_bound ':' opt_slice_bound ']'
+			| LBRACKET opt_slice_bound COLON opt_slice_bound RBRACKET
 				{
 					A_Indices *ai = makeNode(A_Indices);
 					ai->is_slice = true;
@@ -14728,7 +14743,7 @@ opt_target_list: target_list						{ $$ = $1; }
 
 target_list:
 			target_el								{ $$ = list_make1($1); }
-			| target_list ',' target_el				{ $$ = lappend($1, $3); }
+			| target_list COMMA target_el				{ $$ = lappend($1, $3); }
 		;
 
 target_el:	a_expr AS ColLabel
@@ -14763,7 +14778,7 @@ target_el:	a_expr AS ColLabel
 					$$->val = (Node *)$1;
 					$$->location = @1;
 				}
-			| '*'
+			| STAR
 				{
 					ColumnRef *n = makeNode(ColumnRef);
 					n->fields = list_make1(makeNode(A_Star));
@@ -14786,13 +14801,13 @@ target_el:	a_expr AS ColLabel
 
 qualified_name_list:
 			qualified_name							{ $$ = list_make1($1); }
-			| qualified_name_list ',' qualified_name { $$ = lappend($1, $3); }
+			| qualified_name_list COMMA qualified_name { $$ = lappend($1, $3); }
 		;
 
 /*
  * The production for a qualified relation name has to exactly match the
  * production for a qualified func_name, because in a FROM clause we cannot
- * tell which we are parsing until we see what comes after it ('(' for a
+ * tell which we are parsing until we see what comes after it (LPAREN for a
  * func_name, something else for a relation). Therefore we allow 'indirection'
  * which may contain subscripts, and reject that case in the C code.
  */
@@ -14830,7 +14845,7 @@ qualified_name:
 
 name_list:	name
 					{ $$ = list_make1(makeString($1)); }
-			| name_list ',' name
+			| name_list COMMA name
 					{ $$ = lappend($1, makeString($3)); }
 		;
 
@@ -14852,7 +14867,7 @@ file_name:	Sconst									{ $$ = $1; };
 /*
  * The production for a qualified func_name has to exactly match the
  * production for a qualified columnref, because we cannot tell which we
- * are parsing until we see what comes after it ('(' or Sconst for a func_name,
+ * are parsing until we see what comes after it (LPAREN or Sconst for a func_name,
  * anything else for a columnref).  Therefore we allow 'indirection' which
  * may contain subscripts, and reject that case in the C code.  (If we
  * ever implement SQL99-like methods, such syntax may actually become legal!)
@@ -14902,7 +14917,7 @@ AexprConst: Iconst
 					t->location = @1;
 					$$ = makeStringConstCast($2, @2, t);
 				}
-			| func_name '(' func_arg_list opt_sort_clause ')' Sconst
+			| func_name LPAREN func_arg_list opt_sort_clause RPAREN Sconst
 				{
 					/* generic syntax with a type modifier */
 					TypeName *t = makeTypeNameFromNameList($1);
@@ -14944,7 +14959,7 @@ AexprConst: Iconst
 					t->typmods = $3;
 					$$ = makeStringConstCast($2, @2, t);
 				}
-			| ConstInterval '(' Iconst ')' Sconst
+			| ConstInterval LPAREN Iconst RPAREN Sconst
 				{
 					TypeName *t = $1;
 					t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
@@ -14969,8 +14984,8 @@ Iconst:		ICONST									{ $$ = $1; };
 Sconst:		SCONST									{ $$ = $1; };
 
 SignedIconst: Iconst								{ $$ = $1; }
-			| '+' Iconst							{ $$ = + $2; }
-			| '-' Iconst							{ $$ = - $2; }
+			| PLUS Iconst							{ $$ = + $2; }
+			| MINUS Iconst							{ $$ = - $2; }
 		;
 
 /* Role specifications */
@@ -15046,7 +15061,7 @@ RoleSpec:	NonReservedWord
 
 role_list:	RoleSpec
 					{ $$ = list_make1($1); }
-			| role_list ',' RoleSpec
+			| role_list COMMA RoleSpec
 					{ $$ = lappend($1, $3); }
 		;
 
@@ -15411,7 +15426,7 @@ unreserved_keyword:
  * can't be treated as "generic" type or function names.
  *
  * The type names appearing here are not usable as function names
- * because they can be followed by '(' in typename productions, which
+ * because they can be followed by LPAREN in typename productions, which
  * looks too much like a function call for an LR(1) parser.
  */
 col_name_keyword:
@@ -15670,7 +15685,7 @@ makeColumnRef(char *colname, List *indirection,
 		}
 		else if (IsA(lfirst(l), A_Star))
 		{
-			/* We only allow '*' at the end of a ColumnRef */
+			/* We only allow STAR at the end of a ColumnRef */
 			if (lnext(indirection, l) != NULL)
 				parser_yyerror("improper use of \"*\"");
 		}
@@ -15814,7 +15829,7 @@ makeRoleSpec(RoleSpecType type, int location)
 /* check_qualified_name --- check the result of qualified_name production
  *
  * It's easiest to let the grammar production for qualified_name allow
- * subscripts and '*', which we then must reject here.
+ * subscripts and STAR, which we then must reject here.
  */
 static void
 check_qualified_name(List *names, core_yyscan_t yyscanner)
@@ -15831,7 +15846,7 @@ check_qualified_name(List *names, core_yyscan_t yyscanner)
 /* check_func_name --- check the result of func_name production
  *
  * It's easiest to let the grammar production for func_name allow subscripts
- * and '*', which we then must reject here.
+ * and STAR, which we then must reject here.
  */
 static List *
 check_func_name(List *names, core_yyscan_t yyscanner)
@@ -15848,7 +15863,7 @@ check_func_name(List *names, core_yyscan_t yyscanner)
 
 /* check_indirection --- check the result of indirection production
  *
- * We only allow '*' at the end of the list, but it's hard to enforce that
+ * We only allow STAR at the end of the list, but it's hard to enforce that
  * in the grammar, so do it here.
  */
 static List *
@@ -16051,7 +16066,7 @@ doNegate(Node *n, int location)
 	{
 		A_Const *con = (A_Const *)n;
 
-		/* report the constant's location as that of the '-' sign */
+		/* report the constant's location as that of the MINUS sign */
 		con->location = location;
 
 		if (con->val.type == T_Integer)
diff --git a/src/backend/parser/scan.l b/src/backend/parser/scan.l
index e1cae859e8..f0d809c0a1 100644
--- a/src/backend/parser/scan.l
+++ b/src/backend/parser/scan.l
@@ -109,6 +109,7 @@ const uint16 ScanKeywordTokens[] = {
 #define startlit()	( yyextra->literallen = 0 )
 static void addlit(char *ytext, int yleng, core_yyscan_t yyscanner);
 static void addlitchar(unsigned char ychar, core_yyscan_t yyscanner);
+static int map_single_char_token(char c);
 static char *litbufdup(core_yyscan_t yyscanner);
 static char *litbuf_udeescape(unsigned char escape, core_yyscan_t yyscanner);
 static unsigned char unescape_single_char(unsigned char c, core_yyscan_t yyscanner);
@@ -377,10 +378,11 @@ not_equals		"!="
  * appears in the "self" set, it is not to be returned as an Op).  Note
  * that the sets overlap, but each has some chars that are not in the other.
  *
- * If you change either set, adjust the character lists appearing in the
- * rule for "operator"!
+ * If you change "op_chars", adjust the character list appearing in the
+ * rule for "operator", and if you change "self", change map_single_char_token()
+ * to match!
  */
-self			[,()\[\].;\:\+\-\*\/\%\^\<\>\=]
+self			[,()\[\]{}.;\:\+\-\*\/\%\^\<\>\=]
 op_chars		[\~\!\@\#\^\&\|\`\?\+\-\*\/\%\<\>\=]
 operator		{op_chars}+
 
@@ -710,10 +712,7 @@ other			.
 				}
 {dolqfailed}	{
 					SET_YYLLOC();
-					/* throw back all but the initial "$" */
-					yyless(1);
-					/* and treat it as {other} */
-					return yytext[0];
+					yyerror("unterminated dollar quote");
 				}
 <xdolq>{dolqdelim} {
 					if (strcmp(yytext, yyextra->dolqstart) == 0)
@@ -881,7 +880,10 @@ other			.
 
 {self}			{
 					SET_YYLLOC();
-					return yytext[0];
+					int self_token = map_single_char_token(yytext[0]);
+					if (self_token < 0)
+						yyerror("invalid single character token");
+					return self_token;
 				}
 
 {operator}		{
@@ -955,9 +957,13 @@ other			.
 						 * return it as a character token the same way
 						 * that the "self" rule would have.
 						 */
-						if (nchars == 1 &&
-							strchr(",()[].;:+-*/%^<>=", yytext[0]))
-							return yytext[0];
+						if (nchars == 1)
+						{
+							int self_token = map_single_char_token(yytext[0]);
+							if (self_token > 0)
+								return self_token;
+						}
+
 						/*
 						 * Likewise, if what we have left is two chars, and
 						 * those match the tokens ">=", "<=", "=>", "<>" or
@@ -1062,7 +1068,7 @@ other			.
 
 {other}			{
 					SET_YYLLOC();
-					return yytext[0];
+					yyerror("invalid single character token");
 				}
 
 <<EOF>>			{
@@ -1266,6 +1272,57 @@ litbufdup(core_yyscan_t yyscanner)
 	return new;
 }
 
+/*
+ * Return tokens for single characters matching the "self" rule.
+ */
+static int
+map_single_char_token(char c)
+{
+	switch (c)
+	{
+		case ',':
+			return COMMA;
+		case '(':
+			return LPAREN;
+		case ')':
+			return RPAREN;
+		case '[':
+			return LBRACKET;
+		case ']':
+			return RBRACKET;
+		case '{':
+			return LBRACE;
+		case '}':
+			return RBRACE;
+		case '.':
+			return DOT;
+		case ';':
+			return SEMICOLON;
+		case ':':
+			return COLON;
+		case '+':
+			return PLUS;
+		case '-':
+			return MINUS;
+		case '*':
+			return STAR;
+		case '/':
+			return SLASH;
+		case '%':
+			return PERCENT;
+		case '^':
+			return CARET;
+		case '<':
+			return LESS;
+		case '>':
+			return GREATER;
+		case '=':
+			return EQUALS;
+		default:
+			return -1;
+	}
+}
+
 /*
  * Process {integer}.  Note this will also do the right thing with {decimal},
  * ie digits and a decimal point.
